#ifndef E_KBD_BUF_H
#define E_KBD_BUF_H

typedef struct _E_Kbd_Buf           E_Kbd_Buf;
typedef struct _E_Kbd_Buf_Key       E_Kbd_Buf_Key;
typedef struct _E_Kbd_Buf_Keystroke E_Kbd_Buf_Keystroke;

struct _E_Kbd_Buf
{
   const char   *sysdicts;
   Evas_List    *keystrokes;
   Evas_List    *string_matches;
   const char   *actual_string;
   struct {
      int        w, h;
      int        fuzz;
      Evas_List *keys;
   } layout;
};

struct _E_Kbd_Buf_Key
{
   int x, y, w, h;
   const char *key, *key_shift, *key_capslock;
};

struct _E_Kbd_Buf_Keystroke
{
   const char *key;
   int x, y;
   unsigned char shift : 1;
   unsigned char capslock : 1;
};

EAPI E_Kbd_Buf *e_kbd_buf_new(const char *sysdicts);
EAPI void e_kbd_buf_clear(E_Kbd_Buf *kb);
EAPI void e_kbd_buf_layout_clear(E_Kbd_Buf *kb);
EAPI void e_kbd_buf_layout_size_set(E_Kbd_Buf *kb, int w, int h);
EAPI void e_kbd_buf_layout_fuzz_set(E_Kbd_Buf *kb, int fuzz);
EAPI void e_kbd_buf_layout_key_add(E_Kbd_Buf *kb, const char *key, const char *key_shift, const char *key_capslock, int x, int y, int w, int h);
EAPI void e_kbd_buf_pressed_key_add(E_Kbd_Buf *kb, const char *key, int shift, int capslock);
EAPI void e_kbd_buf_pressed_point_add(E_Kbd_Buf *kb, int x, int y, int shift, int capslock);
EAPI const char *e_kbd_buf_actual_string_get(E_Kbd_Buf *kb);
EAPI const Evas_List *e_kbd_buf_string_matches_get(E_Kbd_Buf *kb);
EAPI void e_kbd_buf_backspace(E_Kbd_Buf *kb);
    
#endif
